// MoonDistanceDlg.cpp : implementation file
//

#include "stdafx.h"
#include <math.h>
#include "MoonDistance.h"
#include "MoonDistanceDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define pi 3.14159652

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMoonDistanceDlg dialog

CMoonDistanceDlg::CMoonDistanceDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMoonDistanceDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMoonDistanceDlg)
	RotationAngle = 120.0;
	DistanceCentre = 380000;
	DistanceLune = 0;
	Speed = 0;
	MoonAngle = 85;
	TiltAngle = 30;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMoonDistanceDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMoonDistanceDlg)
	DDX_Text(pDX, ID_ANGLE_ROTATION, RotationAngle);
	DDX_Text(pDX, ID_DISTANCE_CENTRE, DistanceCentre);
	DDX_Text(pDX, ID_DISTANCE_LUNE, DistanceLune);
	DDX_Text(pDX, ID_SPEED, Speed);
	DDX_Text(pDX, ID_ANGLE_LUNE, MoonAngle);
	DDX_Text(pDX, ID_TILT_ANGLE, TiltAngle);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMoonDistanceDlg, CDialog)
	//{{AFX_MSG_MAP(CMoonDistanceDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_COMPUTE, OnCompute)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMoonDistanceDlg message handlers

BOOL CMoonDistanceDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMoonDistanceDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMoonDistanceDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMoonDistanceDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMoonDistanceDlg::OnCompute() 
{
	// TODO: Add your control notification handler code here
	double Distance,
	double EcartDistance;

	UpdateData(TRUE);

	Distance=ComputeDistance(RotationAngle);
	DistanceLune=(int) Distance;
	EcartDistance=ComputeDistance(RotationAngle+0.25)-Distance;
	Speed=((int) 60*EcartDistance);
	UpdateData(FALSE);
}


double CMoonDistanceDlg::ComputeDistance(float Angle) 
{
	double l,a,t,t2;
	double R,r;
	double xa,za;
	double x,y,z;
	double Distance;
	double xl,yl;
	double al;

	R=6371;
	l=(double) pi*53.3/180;
	t=(double) pi*23.4/180;
	a=(double) pi*(Angle+TiltAngle)/180;
	r=R*cos(l);
	xa=R*sin(l)*sin(t);
	za=R*sin(l)*cos(t);
	t2=(double) t*(90-Angle)/90;
	x=xa+r*cos(t2)*cos(a);
	y=r*cos(t2)*sin(a);
	z=za-r*sin(t2);
	al=(double) pi*(MoonAngle+TiltAngle)/180;
	xl=(double) DistanceCentre*cos(al);
	yl=(double) DistanceCentre*sin(al);
	Distance=sqrt((xl-x)*(xl-x)+(yl-y)*(yl-y)+z*z);
	return(Distance);
}
